"""
   SS 2012
   ALP2-Team
   2nd Homework
"""

# 2nd Task

import random

from random import randint

def longest_ones_seq (list):
    """ finds the longest sequence of ones of the list and
        returns the position of the first one and the length of the sequence
        in a tuple.
    """
    max_seq = (0,0)         # (position of the first one, lenght of the sequence)
    current_seq_size = 0    # ones counter

    for i in range(len(list)):
        if list[i] == 1:
            current_seq_size += 1
        else:
            if current_seq_size > max_seq[1]:
                max_seq = (i-current_seq_size, current_seq_size)
            current_seq_size = 0
            
    if current_seq_size > max_seq[1]:
        return (len(list)-current_seq_size,current_seq_size)
    else:
        return max_seq


def test_longest_ones_seq ():

    for i in range (10):
        list = []
        for i in range(20):
                list.append(randint(0,1))
        print(list)
        print(longest_ones_seq(list))

test_longest_ones_seq()

# 3rd Task

def change_money (amount, helper = [200, 100, 50, 20, 10, 5, 2, 1]):
    """ Recursive Solution """

    if helper == []:
        return []

    result = [amount // helper[0]]
    result.extend (change_money (amount % helper[0], helper[1:]))

    return result


def change_money_iterative (amount, helper = [200, 100, 50, 20, 10, 5, 2, 1]):
    """ Iterative Solution. """

    result = []

    for i in helper:
        result.append (amount // i)
        amount %= i

    return result


def test_change_money ():
    def check (amount, expected):
        recursive = change_money (amount)
        iterative = change_money_iterative (amount)
        print (recursive, recursive == expected, iterative, iterative == expected)

    check (42, [0,0,0,2,0,0,1,0])
    check (1337, [6,1,0,1,1,1,1,0])
    check (4711, [23,1,0,0,1,0,0,1])

# 4th Task

""" We have two solutions for the simulation of the Monty Hall Problem.
    The first solution uses three different functions.
    The second solution uses only one function to simulate the three different
    strategies.
"""

from random import randint, choice

# first solution

def monty_hall_never_change():   
    auto = randint(0,2)
    first_choice = randint(0,2)    
    return auto == first_choice  # only if the first_choice was right the player
                                 # wins because he never changes the first choice

def monty_hall_always_change():    
    auto = randint(0,2)
    first_choice = randint(0,2)    
    return auto != first_choice  # the player always wins, if the first choice was
                                 # wrong because he always changes this choice

def monty_hall_random_change():
    auto = randint(0,2)
    first_choice = randint(0,2)
    change = choice([True, False]) # the decision to change is taken randomly
    return (auto == first_choice and change) or (auto != first_choice) and not change

# test the first solution of the 4th Task

def monty_hall_test (num_of_runs = 10000):
    print("Test first solution")

    win_strategy = {"random change":0, "never change":0, "always change":0}
  
    for i in range (num_of_runs):
        if monty_hall_random_change ():
            win_strategy["random change"] += 1

    for i in range (num_of_runs):
        if monty_hall_always_change ():
            win_strategy["always change"] += 1

    for i in range (num_of_runs):
        if monty_hall_never_change ():
            win_strategy["never change"] += 1
    print ("Test the 4th Task")
    print ("Games: ", num_of_runs)
    print ("Winning cars for each strategy:")
    print (win_strategy)       

monty_hall_test(100000)       

# second solution 

def monty_hall (changeChoice = True, randomChange = True):
    """ Simulation of the Monty Hall Problem with two arguments to simulate
        three strategies with the same function.
    """   
    auto = randint(0,2)
    first_choice = randint(0,2)
    change = choice([True, False])

    if changeChoice and not randomChange: # always changes the choice
        if auto == first_choice:
            return False
        else:
            return True

    if changeChoice and randomChange:     # the player decides randomly to change
        if change:
            if auto == first_choice:
                return False
            else:
                return True
        else:
            if auto == first_choice:
                return True
            else:
                return False
            
    if not changeChoice:                # never changes the first choice
        if auto == first_choice:
            return True
        else:
            return False
    else:
        print("(False, True) is not a valid combination of the argument values")
        return None

# test the second solution of the 4th Task

def monty_hall_repeat (num_of_runs = 10000):
    print("Test second solution")
    
    win_strategy = {"random change":0, "never change":0, "always change":0}
  
    for i in range (num_of_runs):
        if monty_hall (True, True):
            win_strategy["random change"] += 1

    for i in range (num_of_runs):
        if monty_hall (True, False):
            win_strategy["always change"] += 1

    for i in range (num_of_runs):
        if monty_hall (False, False):
            win_strategy["never change"] += 1
    print ("Games: ", num_of_runs)
    print ("Winning cars for each strategy:")
    print (win_strategy)

monty_hall_repeat(100000)

# 5th Task

def farb_frequenzen (bild):
    frequenzen = {}
    for zeile in bild:
        for farbe in zeile:
            if farbe in frequenzen:
                frequenzen[farbe] += 1
            else:
                frequenzen[farbe] = 1
    return frequenzen

def test_farb_frequenzen ():
    def check (bild, erwartet):
        result = farb_frequenzen (bild)
        print (erwartet, result, erwartet == result)

    check ([[(255, 255, 0), (255, 255, 0)], [(255, 0, 255), (0, 0, 0)]],
            {(255, 255, 0): 2, (255, 0, 255): 1, (0, 0, 0): 1})
    check ([[(0, 0, 0)] * 3, [(127, 127, 127)] * 3, [(0, 0, 0)] * 3],
            {(127, 127, 127): 3, (0, 0, 0): 6})

